#property copyright "  "
#property link      "  "

#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1 clrMagenta
#property indicator_color2 clrLime
#property indicator_color3 clrRed
#property indicator_color4 clrLime
#property indicator_color5 clrMagenta
#property indicator_color6 clrLightSkyBlue
#property indicator_style6 2
#property indicator_color7 clrLightSkyBlue
#property indicator_style7 2
#property indicator_color8 clrGold

int BandPeriod = 20;
int Fast = 12;
int Slow = 26;
extern int Smooth = 5;
double StdDevNumber = 1.0;
double buf01[];
double buf02[];
double buf03[];
double buf04[];
double buf05[];
double buf06[];
double buf07[];
double buf08[];



int init() {
   IndicatorBuffers(8);
   SetIndexBuffer(0, buf01);
   SetIndexBuffer(1, buf02);
   SetIndexBuffer(2, buf03);
   SetIndexBuffer(3, buf04);
   SetIndexBuffer(4, buf05);
   SetIndexBuffer(5, buf06);
   SetIndexBuffer(6, buf07);
   SetIndexBuffer(7, buf08);
   SetIndexLabel(0, NULL);
   SetIndexLabel(1, NULL);
   SetIndexLabel(2, NULL);
   SetIndexLabel(3, NULL);
   SetIndexLabel(4, NULL);
   SetIndexLabel(5, NULL);
   SetIndexLabel(6, NULL);
   SetIndexLabel(7, NULL);
   SetIndexStyle(0, DRAW_NONE);
   SetIndexStyle(1, DRAW_ARROW, EMPTY, 0);
   SetIndexArrow(1, 108);
   SetIndexStyle(2, DRAW_ARROW, EMPTY, 0);
   SetIndexArrow(2, 108);
   SetIndexStyle(3, DRAW_NONE);
   SetIndexStyle(4, DRAW_NONE);
   SetIndexStyle(5, DRAW_LINE);
   SetIndexStyle(6, DRAW_LINE);
   SetIndexStyle(7, DRAW_ARROW, EMPTY, 2);
   SetIndexArrow(7, 161);
   IndicatorShortName(" ");
   return (0);
}
int deinit() {
   return (0);
}
int start() {
   double imacd_0;
   double acct;
   double ttun;
   double perfect;
   int indCount = IndicatorCounted();
   int allbars = Bars - indCount;
   for (int i = allbars; i >= 0; i--) {
      imacd_0 = iMACD(Symbol(), 0, Fast, Slow, Smooth, PRICE_CLOSE, MODE_MAIN, i);
      buf01[i] = imacd_0;
      if (buf01[i] > buf01[i + 1]) {
         buf02[i] = buf01[i];
         buf03[i] = EMPTY_VALUE;
      } else {
         buf03[i] = buf01[i];
         buf02[i] = EMPTY_VALUE;
      }
      acct = 0;
      for (int shift = i + BandPeriod - 1; shift >= i; shift--) acct += buf01[shift];
      ttun = acct / BandPeriod;
      acct = 0;
      for (shift = i + BandPeriod - 1; shift >= i; shift--) acct += (buf01[shift] - ttun) * (buf01[shift] - ttun);
      perfect = MathSqrt(acct / BandPeriod);
      if (buf01[i] > ttun) {
         buf04[i] = ttun;
         buf05[i] = EMPTY_VALUE;
         if (buf04[i + 1] == EMPTY_VALUE) buf04[i + 1] = buf05[i + 1];
      } else {
         if (buf01[i] < ttun) {
            buf05[i] = ttun;
            buf04[i] = EMPTY_VALUE;
            if (buf05[i + 1] == EMPTY_VALUE) buf05[i + 1] = buf04[i + 1];
         } else {
            buf04[i] = buf04[i + 1];
            buf05[i] = buf05[i];
         }
      }
      buf06[i] = ttun + StdDevNumber * perfect;
      buf07[i] = ttun - StdDevNumber * perfect;
      buf08[i] = EMPTY_VALUE;
      if (buf01[i] > 0.0) {
         if (buf01[i + 1] <= 0.0) buf08[i] = 0;
      } else
         if (buf01[i + 1] > 0.0) buf08[i] = 0;
   }
   return (0);
}
